Script pour les pièces

From FreeCAD Documentation
Jump to: navigation, search
This page is a translated version of the page Topological data scripting and the translation is 100% complete.

Other languages:
čeština • ‎Deutsch • ‎English • ‎español • ‎français • ‎Bahasa Indonesia • ‎italiano • ‎polski • ‎português • ‎română • ‎русский • ‎svenska • ‎Türkçe • ‎中文 • ‎中文(中国大陆)‎
Arrow-left.svg Page précédente: Script pour le maillage
Page suivante: Mesh to Part Arrow-right.svg
Base ExampleCommandModel.png Tutoriel
Thème
Programming
Niveau
Intermediate
Temps d'exécution estimé
Auteur
Version de FreeCAD
Fichier(s) exemple(s)



Cette page décrit différentes méthodes pour créer et modifier des pièces avec Python.
Avant de lire cette page, si vous n'êtes pas familier avec la programmation Python, vous pouvez vous diriger sur cette page d'introduction à Python et scripts de base en Python pour FreeCAD.

Introduction

Ici nous allons vous expliquer comment contrôler la boîte à outils (Part Module) ou de n'importe quel script externe, directement à partir de l'interpréteur Python inclus dans FreeCAD, .
Assurez-vous de parcourir l'article de familiarisation et scripts de base si vous avez besoin de plus amples renseignements sur la façon dont les scripts Python fonctionnent dans FreeCAD.

Class Diagram

Ceci est un Unified Modeling Language (UML) de la classe la plus importante de Part Module:

Python classes of the Part module

Figures géométriques

Les objets géométriques sont la base de tous les objets topologiques :

  • Geom La classe de base des objets géométriques
  • Line Une ligne droite en 3D, défini par un point de départ et point d'arrivée
  • Circle Circle or circle segment défini par un point central, un point de départ et un point d'arrivée
  • ...... Et bien plus encore très rapidement

Topology

Sont aussi disponibles des données de type topologique:

  • Compound Groupe de types différents d'objets topologiques.
  • Compsolid Un groupe de solides reliés par leurs faces. C'est un concept des notions de WIRE (filaire,bord..) et SHELL (coquille,enveloppe) des solides.
  • Solid Une portion de l'espace limité par son enveloppe. Il est en 3 dimensions.
  • Shell Un groupe de faces reliés par leurs bords.Un "SHELL" peut être ouvert ou fermé.
  • Face En 2D, c'est une surface plane; en 3D, c'est une seule face du volume. Sa géométrie est coupée par des contours. Il est en deux dimensions.
  • Wire Un ensemble relié par ses VERTEX (sommets). Il peut être de contour ouvert ou fermé suivant si les sommets sont reliés ou non.
  • Edge Elément topologique correspondant à une courbe retenue. Un "Edge" est généralement limité par des sommets. Il a une dimension.
  • Vertex Elément topologiques correspondant à un point. Il n'a pas de dimension.
  • Shape Est le terme générique pour traduire tout ce qui précède.

Exemple rapide : Création topologique simple

Wire


Nous allons créer une topologie avec une géométrie toute simple.
Nous devrons veiller à ce que les sommets des pièces géométriques soient à la même position, quatre sommets, deux cercles et deux lignes.

Création de la géométrie

Nous devons d'abord créer les parties distinctes géométriques en filaire.
Nous devons veiller à ce que tous les sommets des pièces géométriques qui vont êtres raccordées soient à la même position.
Sinon, plus tard nous pourrions ne pas être en mesure de relier les pièces géométriques en une topologie!

Donc, nous créons d'abord les points:

from FreeCAD import Base
V1 = Base.Vector(0,10,0)
V2 = Base.Vector(30,10,0)
V3 = Base.Vector(30,-10,0)
V4 = Base.Vector(0,-10,0)

Arc

Circle


Pour créer un arc de cercle, nous créons un point de repère puis nous créons l'arc de cercle passant par trois points:

VC1 = Base.Vector(-10,0,0)
C1 = Part.Arc(V1,VC1,V4)
# and the second one
VC2 = Base.Vector(40,0,0)
C2 = Part.Arc(V2,VC2,V3)

Ligne

Line


La ligne segment peut être créée très simplement en dehors des points :

L1 = Part.LineSegment(V1,V2)
# and the second one
L2 = Part.LineSegment(V3,V4)

Note: dans FreeCAD 0.16 Part.Line était utilisé, depuis la version FreeCAD 0.17 Part.LineSegment est utilisé

Tout relier

La dernière étape consiste à relier les éléments géométriquement ensemble, et façonner une forme topologique:

S1 = Part.Shape([C1,L1,C2,L2])

Construire un prisme

Maintenant nous allons extruder notre forme filaire dans une direction, et créer une forme en 3 Dimensions:

W = Part.Wire(S1.Edges)
P = W.extrude(Base.Vector(0,0,10))

Affichons le tout

Part.show(P)

Création de formes simples

Vous pouvez créer facilement des formes topologiques avec "make...()" qui est une méthode du "Module Part":

b = Part.makeBox(100,100,100)
Part.show(b)

La combinaison de make...() avec d'autres methodes sont disponibles:

  • makeBox(l,w,h): Construit un cube et pointe sur p dans la direction d et de dimensions (longueur,largeur,hauteur).
  • makeCircle(radius): Construit un cercle de rayon (r).
  • makeCone(radius1,radius2,height): Construit un cône de (rayon1,rayon2,hauteur).
  • makeCylinder(radius,height): Construit un cylindre de (rayon,hauteur).
  • makeLine((x1,y1,z1),(x2,y2,z2)): Construit une ligne aux coordonnées (x1,y1,z1),(x2,y2,z2) dans l'espace 3D.
  • makePlane(length,width): Construit un rectangle de (longueur,largeur).
  • makePolygon(list): Construit un polygone (liste de points).
  • makeSphere(radius): Construit une sphère de (rayon).
  • makeTorus(radius1,radius2): Construit un tore de (rayon1,rayon2).

La liste complète des API du module est sur la page Part API.

Importer les modules nécessaires

Nous avons d'abord besoin d'importer le module Part afin que nous puissions utiliser son contenu Python.
Nous allons également importer le module Base à l'intérieur du module de FreeCAD:

import Part
from FreeCAD import Base

Création d'un Vecteur

Les Vecteurs sont l'une des informations les plus importantes lors de la construction des formes géométriques.
Ils contiennent habituellement 3 nombres (mais pas toujours) les coordonnées cartésiennes x, y et z.
Vous pouvez créez un vecteur comme ceci:

myVector = Base.Vector(3,2,0)

Nous venons de créer un vecteur de coordonnées x = 3, y = 2, z = 0.
Dans le module Part, les vecteurs sont utilisés partout.
Le module Part utilise aussi une autre façon de représenter un point, appelé Vertex, qui est simplement un conteneur pour un vecteur.
Vous pouvez accéder aux vecteurs d'un sommet comme ceci:

myVertex = myShape.Vertexes[0]
print myVertex.Point
> Vector (3, 2, 0)

Création d'une arête (edge)

Une arête (bord) n'est rien d'autre qu'une ligne avec deux Vertex (sommets):

edge = Part.makeLine((0,0,0), (10,0,0))
edge.Vertexes
> [<Vertex object at 01877430>, <Vertex object at 014888E0>]

PS: Vous pouvez aussi créer un arête en donnant deux Vecteurs:

vec1 = Base.Vector(0,0,0)
vec2 = Base.Vector(10,0,0)
line = Part.LineSegment(vec1,vec2)
edge = line.toShape()

Vous pouvez trouver la longueur et le centre d'une arête comme ceci:

edge.Length
> 10.0
edge.CenterOfMass
> Vector (5, 0, 0)

Mise en forme à l'écran

Jusqu'à présent, nous avons créé un objet a arêtes vives (bords), mais il n'est pas visible à l'écran.
C'est parce que nous n'avons manipulé que des objets en Python.
L'écran FreeCAD n'affiche uniquement que les vues 3D que vous lui demandez d'afficher.
Pour cela, nous utilisons une méthode simple:

Part.show(edge)

La fonction show crée un objet dans notre document FreeCAD et assigne notre forme "edge" à cela.
Utilisez cette commande chaque fois que vous voudrez afficher votre forme géométrique à l'écran.

Création d'un contour (Wire)

Un contour est une ligne multi-arêtes, et peut être créé dans une liste d'arêtes ou même une liste de lignes (fils):

edge1 = Part.makeLine((0,0,0), (10,0,0))
edge2 = Part.makeLine((10,0,0), (10,10,0))
wire1 = Part.Wire([edge1,edge2]) 
edge3 = Part.makeLine((10,10,0), (0,10,0))
edge4 = Part.makeLine((0,10,0), (0,0,0))
wire2 = Part.Wire([edge3,edge4])
wire3 = Part.Wire([wire1,wire2])
wire3.Edges
> [<Edge object at 016695F8>, <Edge object at 0197AED8>, <Edge object at 01828B20>, <Edge object at 0190A788>]
Part.show(wire3)

Part.show (wire3) permet d'afficher les 4 bords qui composent notre contour filaire.
D'autres informations utiles, peuvent être facilement récupérées:

wire3.Length
> 40.0
wire3.CenterOfMass
> Vector (5, 5, 0)
wire3.isClosed()
> True
wire2.isClosed()
> False

Création d'une face

Seul les faces à contour fermés seront valides.
Dans cet exemple, wire3 est un contour fermé, et Wire2 est un contour ouvert (voir ci-dessus)

face = Part.Face(wire3)
face.Area
> 99.999999999999972
face.CenterOfMass
> Vector (5, 5, 0)
face.Length
> 40.0
face.isValid()
> True
sface = Part.Face(wire2)
face.isValid()
> False

Seul les faces auront une superficie, mais les lignes et les bords (arêtes) n'en possède pas .

Création d'un cercle

Un cercle est créé simplement comme ceci:

circle = Part.makeCircle(10)
circle.Curve
> Circle (Radius : 10, Position : (0, 0, 0), Direction : (0, 0, 1))

Si vous voulez le créer à une certaine position et avec une certaine direction:

ccircle = Part.makeCircle(10, Base.Vector(10,0,0), Base.Vector(1,0,0))
ccircle.Curve
> Circle (Radius : 10, Position : (10, 0, 0), Direction : (1, 0, 0))

ccircle sera créé à une distance de 10 de l’origine x et sera face à l'extérieur le long de l'axe des x. Remarque: makeCircle accepte uniquement Base.Vector() pour la position et les paramètres normaux, pas les tuples. Vous pouvez également créer une partie du cercle en donnant un angle de début et de fin:

from math import pi
arc1 = Part.makeCircle(10, Base.Vector(0,0,0), Base.Vector(0,0,1), 0, 180)
arc2 = Part.makeCircle(10, Base.Vector(0,0,0), Base.Vector(0,0,1), 180, 360)

Si nous joignions les deux arcs arc1 et arc2 nous obtiendrons un cercle.
L'angle fourni doit être exprimé en degrés, s'il sont en radians, vous devez les convertir en degrès avec la formule: degrés = radians * 180/PI ou en utilisant le module mathématiques Python (après avoir fait import math, bien sûr):

degrees = math.degrees(radians)

Création d'un arc sur des points (repères)

Malheureusement, il n'existe pas de fonction makeArc mais nous avons la fonction Part.Arc pour créer un arc sur trois points de référence.
Fondamentalement, nous pouvons supposer un arc attaché sur un point de départ, passant sur un point central et se termine sur un point final en .
Part.Arc crée un objet arc pour lequel .ToShape() doit être appelée pour obtenir un objet ligne (edge), de cette manière nous utiliserons Part.LineSegment au lieu de Part.makeLine.

arc = Part.Arc(Base.Vector(0,0,0),Base.Vector(0,5,0),Base.Vector(5,5,0))
arc
> <Arc object>
arc_edge = arc.toShape()

Arc travaille uniquement avec Base.Vector() pour les points mais pas pour les tuples.
arc_edge est ce qui sera affiché à l'aide Part.show (arc_edge).
Vous pouvez également obtenir un arc de cercle en utilisant une partie de cercle:

from math import pi
circle = Part.Circle(Base.Vector(0,0,0),Base.Vector(0,0,1),10)
arc = Part.Arc(circle,0,pi)

Les arcs Arc sont des lignes (edges). Ils peuvent donc être utilisés aussi comme contour en filaire.

Création de polygones

Un polygone est tout simplement une ligne (wire) avec de multiples lignes droites.
La fonction makePolygon crée une liste de points et crée une ligne de points en points:

lshape_wire = Part.makePolygon([Base.Vector(0,5,0),Base.Vector(0,0,0),Base.Vector(5,0,0)])

Création de courbes de Bézier

Les courbes de Bézier sont utilisées pour modéliser des courbes lisses à l'aide d'une série de repères (points de contrôle) avec un nombre de repères représentants la précision (fluidité de la courbe) optionnel. La fonction ci-dessous fait un Part.BezierCurve avec une série de points FreeCAD.Vector. (Note : l'indice du premier repère et du nombre commencent à 1, et pas à 0.)

def makeBCurveEdge(Points):
   geomCurve = Part.BezierCurve()
   geomCurve.setPoles(Points)
   edge = Part.Edge(geomCurve)
   return(edge)

Création d'une forme plane

Une forme plane, est tout simplement une surface plane rectangulaire.
La méthode utilisée pour créer une forme plane est la suivante: makePlane(longueur, largeur, [point de départ, direction]).
Par défaut point de départ = Vecteur(0,0,0) et direction = Vecteur(0,0,1).
L'utilisation point de départ = Vecteur(0,0,1) va créer la forme sur l' axe z positif, tandis que direction = Vecteur(1,0,0) va créer la forme sur l'axe x positif:
(Pour s'y retrouver un peu sur les axes, Vecteur ( 0 , 0 , 1 ) est égal à Vecteur ( X=0 , Y=0 , Z=1 ) l'ordre des axes sera toujours ( x , y , z ))

plane = Part.makePlane(2,2)
plane
><Face object at 028AF990>
plane = Part.makePlane(2, 2, Base.Vector(3,0,0), Base.Vector(0,1,0))
plane.BoundBox
> BoundBox (3, 0, 0, 5, 0, 2)

BoundBox est un rectangle qui possède une diagonale commençant sur le plan (3,0,0) et se terminant à (5,0,2).
L'épaisseur de la boîte (Box) dans l'axe y est égal à zéro, car notre forme est totalement plane.

PS: makePlane accepte uniquement Base.Vector() pour start_pnt et dir_normal mais pas les tuples.

Création d'une ellipse

Pour créer une ellipse, il existe plusieurs façons:

Part.Ellipse()

Créez une ellipse avec un grand rayon = 2 et un petit rayon = 1 et un centre = (0,0,0).

Part.Ellipse(Ellipse)

Créez une copie des données de l'ellipse

Part.Ellipse(S1,S2,Center)

Crée une ellipse positionnée au point "Center", le plan de l'ellipse est défini par Center, S1 et S2,
le grand axe est définit par Center et S1,
son grand rayon est la distance entre Center et S1,
son petit rayon est la distance entre S2 et le grand axe.

Part.Ellipse(Center,MajorRadius,MinorRadius)

Crée une ellipse avec un grand rayon MajorRadius et un petit rayon MinorRadius et situé dans le plan défini par (0,0,1)

eli = Part.Ellipse(Base.Vector(10,0,0),Base.Vector(0,5,0),Base.Vector(0,0,0))
Part.show(eli.toShape())

Dans le code ci-dessus, nous avons passé S1 (Grand rayon), S2 (Petit rayon) et le centre (les coordonnées centrales).
De même que l'Arc, l'Ellipse crée également un objet Ellipse mais pas d'arête (bords), nous avons donc besoin de le convertir en arête à l'aide toShape() pour l'afficher.

PS: Arc accepte uniquement Base.Vector() pour les points mais pas les tuples.

eli = Part.Ellipse(Base.Vector(0,0,0),10,5)
Part.show(eli.toShape())

pour construire l'Ellipse ci-dessus, nous avons entré les coordonnées centrales, le Grand rayon et le Petit rayon.

Création d'un Tore

Nous créons un Tore en utilisant la méthode makeTorus( rayon1 , rayon2 , [ pnt , dir , angle1 , angle2 , angle ] ).
Par défaut,
Rayon1 = est le rayon du grande cercle
Rayon2 = est le rayon du petit cercle,
pnt = Vecteur(0,0,0),pnt est le centre de tore
dir = Vecteur(0,0,1), dir est la direction normale
angle1 = 0, est l'angle de début pour le petit cercle exprimé en radians
angle2 = 360 est l'angle de fin pour le petit cercle exprimé en radians
angle = 360 le dernier paramètre est la section du tore

torus = Part.makeTorus(10, 2)

Le code ci-dessus créera un tore avec un diamètre de 20 (rayon de 10) et une épaisseur de 4 (rayon du petite cercle 2)

tor=Part.makeTorus(10, 5, Base.Vector(0,0,0), Base.Vector(0,0,1), 0, 180)

Le code ci-dessus créera une portion du tore.

tor=Part.makeTorus(10, 5, Base.Vector(0,0,0), Base.Vector(0,0,1), 0, 360, 180)

Le code ci-dessus créera un demi tore; seul le dernier paramètre change à savoir l'angle et les angles restants sont prédéfinis.
En donnant un angle de 180 degrés, créez un tore de 0 à 180 degrés, c'est à dire un demi tore.

Création d'un cube ou d'un parallélépipède

Utilisez makeBox(length,width,height,[pnt,dir]).
Par défaut pnt=Vector(0,0,0) and dir=Vector(0,0,1).

box = Part.makeBox(10,10,10)
len(box.Vertexes)
> 8

Création d'une Sphère

Nous utiliserons makeSphere ( rayon , [ pnt , dir , angle1 , angle2 , angle3 ] ).
rayon = rayon de la sphère par défaut,
pnt = Vecteur (0,0,0),
dir = Vecteur (0,0,1),
angle1 = -90, verticale minimale de la sphère
angle2 = 90, verticale maximale de la sphère
angle3 = 360, le diamètre de la sphère.

sphere = Part.makeSphere(10)
hemisphere = Part.makeSphere(10,Base.Vector(0,0,0),Base.Vector(0,0,1),-90,90,180)

Création d'un Cylindre

Nous utiliserons makeCylinder(radius,height,[pnt,dir,angle]).
Par défaut,
pnt=Vector(0,0,0), dir=Vector(0,0,1) et angle=360.

cylinder = Part.makeCylinder(5,20)
partCylinder = Part.makeCylinder(5,20,Base.Vector(20,0,0),Base.Vector(0,0,1),180)

Création d'un Cône

Nous utiliserons makeCone(radius1,radius2,height,[pnt,dir,angle]).
Par défaut,
pnt=Vector(0,0,0), dir=Vector(0,0,1) et angle=360.

cone = Part.makeCone(10,0,20)
semicone = Part.makeCone(10,0,20,Base.Vector(20,0,0),Base.Vector(0,0,1),180)

Modification d'une forme

Il y a plusieurs manières de modifier des formes. Certaines sont de simples opérations de transformation telles que le déplacement ou la rotation de formes, d'autres sont plus complexes telles que fusion et soustraction d'une forme à une autre.

Opérations de Transformation

Transformer une forme

La transformation est l'action de déplacer une forme d'un endroit à un autre.
Toute forme (arête, face, cube, etc ..) peut être transformé de la même manière:

myShape = Part.makeBox(2,2,2)
myShape.translate(Base.Vector(2,0,0))

Cette commande va déplacer notre forme "myShape" de 2 unités dans la direction x.

Rotation d'une forme

Pour faire pivoter une forme, vous devez spécifier le centre de rotation, l'axe, et l'angle de rotation:

myShape.rotate(Vector(0,0,0),Vector(0,0,1),180)

Cette opération va faire pivoter notre forme de 180 degrés sur l'axe z.

Transformations génériques avec matrices

Une matrice est un moyen très simple de mémoriser les transformations dans le mode 3D. Dans une seule matrice, vous pouvez définir les valeurs de transformation, rotation et mise à l'échelle à appliquer à un objet.
Par exemple:

myMat = Base.Matrix()
myMat.move(Base.Vector(2,0,0))
myMat.rotateZ(math.pi/2)

PS: les matrices de FreeCAD travaillent en radians. En outre presque toutes les opérations matricielles qui travaillent avec un vecteur peut aussi avoir 3 nombres de sorte que ces 2 lignes effectuent le même travail:

myMat.move(2,0,0)
myMat.move(Base.Vector(2,0,0))

Lorsque notre matrice est paramétrée, nous pouvons l'appliquer à notre forme. FreeCAD fournit nous fournit 2 méthodes: transformShape() et transformGeometry().
La différence est que, avec la première, vous ne verez pas de différence (voir "mise à l'échelle d'une forme" ci-dessous).
Donc, nous pouvons opérer notre transformation comme ceci:

myShape.transformShape(myMat)

ou

myShape.transformGeometry(myMat)

Echelle du dessin (forme)

Changer l'échelle d'une forme est une opération plus dangereuse, car, contrairement à la translation ou à la rotation, le changement d'échelle non uniforme (avec des valeurs différentes pour x, y et z) peut modifier la structure de la forme!
Par exemple, le redimensionnement d'un cercle avec une valeur plus élevée horizontalement que verticalement le transformera en une ellipse, qui mathématiquement très différent.
Pour modifier l'échelle, nous ne pouvons pas utiliser le transformShape, nous devons utiliser transformGeometry():

myMat = Base.Matrix()
myMat.scale(2,1,1)
myShape=myShape.transformGeometry(myMat)

Opérations Booléennes

Soustraction

Soustraire une forme d'une autre est appelé, dans le jargon OCC/FreeCAD "cut" (coupe) et,
se fait de cette manière:

cylinder = Part.makeCylinder(3,10,Base.Vector(0,0,0),Base.Vector(1,0,0))
sphere = Part.makeSphere(5,Base.Vector(5,0,0))
diff = cylinder.cut(sphere)

Intersection

De la même manière, l'intersection entre 2 formes est appelé "common" et se fait de cette manière:

cylinder1 = Part.makeCylinder(3,10,Base.Vector(0,0,0),Base.Vector(1,0,0))
cylinder2 = Part.makeCylinder(3,10,Base.Vector(5,0,-5),Base.Vector(0,0,1))
common = cylinder1.common(cylinder2)

Fusion

La fusion "fuse", fonctionne de la même manière:

cylinder1 = Part.makeCylinder(3,10,Base.Vector(0,0,0),Base.Vector(1,0,0))
cylinder2 = Part.makeCylinder(3,10,Base.Vector(5,0,-5),Base.Vector(0,0,1))
fuse = cylinder1.fuse(cylinder2)

Section

Une section, est l'intersection entre une forme solide et une forme plane.
Elle retournera une courbe d'intersection et sera composée de bords (edges, arêtes).

cylinder1 = Part.makeCylinder(3,10,Base.Vector(0,0,0),Base.Vector(1,0,0))
cylinder2 = Part.makeCylinder(3,10,Base.Vector(5,0,-5),Base.Vector(0,0,1))
section = cylinder1.section(cylinder2)
section.Wires
> []
section.Edges
> [<Edge object at 0D87CFE8>, <Edge object at 019564F8>, <Edge object at 0D998458>, 
 <Edge  object at 0D86DE18>, <Edge object at 0D9B8E80>, <Edge object at 012A3640>, 
 <Edge object at 0D8F4BB0>]

Extrusion

L'extrusion est une action de "pousser" une forme plane dans une certaine direction et résultant en un corps solide.
Par exemple, pousser sur un cercle pour le transformer en tube:

circle = Part.makeCircle(10)
tube = circle.extrude(Base.Vector(0,0,2))

Si votre cercle est vide, vous obtiendrez un tube vide.
Mais si votre cercle est un disque avec une face pleine, vous obtiendrez un cylindre solide:

wire = Part.Wire(circle)
disc = Part.Face(wire)
cylinder = disc.extrude(Base.Vector(0,0,2))

Exploration de la forme (shape)

Vous pouvez facilement explorer la structure de ses données topologique:

import Part
b = Part.makeBox(100,100,100)
b.Wires
w = b.Wires[0]
w
w.Wires
w.Vertexes
Part.show(w)
w.Edges
e = w.Edges[0]
e.Vertexes
v = e.Vertexes[0]
v.Point

En tapant ce code dans l'interpréteur Python, vous aurez une bonne compréhension de la structure de Part objets.
Ici, notre commande makebox() créé une forme solide. Ce solide, comme tous les solides Part, contiennent des faces. Une face est constituée de lignes, qui sont un ensemble de bords, arêtes qui délimitent la face. Chaque face a au moins un contour fermé (il peut en avoir plus si la face comporte un ou plusieurs trou). Dans une ligne, nous pouvons voir chaque côté séparément, et nous pouvons voir les sommets (Vertex) de chaque bord ou arête. Lignes et arêtes n'ont que deux sommets, évidemment.

Analyse des arêtes (Edge)

Dans le cas d'un bord (ou arête), qui est une courbe arbitraire, il est fort probable que vous voulez faire une discrétisation. Dans FreeCAD, les bords sont paramétrés par leurs longueurs.
Cela signifie, que vous pouvez suivre une arête/courbe par sa longueur:

import Part
box = Part.makeBox(100,100,100)
anEdge = box.Edges[0]
print anEdge.Length

Maintenant, vous pouvez accéder à un grand nombre de propriétés de l'arête en utilisant sa longueur comme une position.
C'est à dire que, si l'arête(ou bord) a une longueur de 100 mm la position de départ est 0 et sa position extrème est 100.

anEdge.tangentAt(0.0)      # tangent direction at the beginning
anEdge.valueAt(0.0)        # Point at the beginning
anEdge.valueAt(100.0)      # Point at the end of the edge
anEdge.derivative1At(50.0) # first derivative of the curve in the middle
anEdge.derivative2At(50.0) # second derivative of the curve in the middle
anEdge.derivative3At(50.0) # third derivative of the curve in the middle
anEdge.centerOfCurvatureAt(50) # center of the curvature for that position
anEdge.curvatureAt(50.0)   # the curvature
anEdge.normalAt(50)        # normal vector at that position (if defined)

Utilisation de la sélection

Ici, nous allons voir comment nous pouvons utiliser la fonction de sélection, quand l'utilisateur a fait une sélection dans la visionneuse.
Tout d'abord, nous créons une boîte (box) et nous l'affichons dans la fen^etre de vue.

import Part
Part.show(Part.makeBox(100,100,100))
Gui.SendMsgToActiveView("ViewFit")

Sélectionnez maintenant des faces ou arêtes.
Avec ce script, vous pouvez parcourir tous les objets sélectionnés et visionner leurs sous-éléments:

for o in Gui.Selection.getSelectionEx():
	print o.ObjectName
	for s in o.SubElementNames:
		print "name: ",s
	for s in o.SubObjects:
		print "object: ",s

Sélectionnez quelques bords et ce script va calculer la longueur:

length = 0.0
for o in Gui.Selection.getSelectionEx():
	for s in o.SubObjects:
		length += s.Length
print "Length of the selected edges:" ,length

Exemple Complet: "The OCC bottle"

L'exemple OpenCasCade Technology Tutorial vous montre comment faire une bouteille.

C’est un bon exercice pour FreeCAD. Si vous suivez notre exemple ci-dessous et la page OCC simultanément, vous verre comment les structures OCC sont implémentées dans FreeCAD. Le script complet ci-dessous est également inclus dans l’installation de FreeCAD (dans le dossier Mod / Part) et peut être appelé à partir de l'interpréteur Python en tapant:

import Part
import MakeBottle
bottle = MakeBottle.makeBottle()
Part.show(bottle)

Le script complet

Ici, le script complet de MakeBottle.py (extension .py):

import Part, FreeCAD, math
from FreeCAD import Base

def makeBottle(myWidth=50.0, myHeight=70.0, myThickness=30.0):
   aPnt1=Base.Vector(-myWidth/2.,0,0)
   aPnt2=Base.Vector(-myWidth/2.,-myThickness/4.,0)
   aPnt3=Base.Vector(0,-myThickness/2.,0)
   aPnt4=Base.Vector(myWidth/2.,-myThickness/4.,0)
   aPnt5=Base.Vector(myWidth/2.,0,0)
   
   aArcOfCircle = Part.Arc(aPnt2,aPnt3,aPnt4)
   aSegment1=Part.LineSegment(aPnt1,aPnt2)
   aSegment2=Part.LineSegment(aPnt4,aPnt5)
   aEdge1=aSegment1.toShape()
   aEdge2=aArcOfCircle.toShape()
   aEdge3=aSegment2.toShape()
   aWire=Part.Wire([aEdge1,aEdge2,aEdge3])
   
   aTrsf=Base.Matrix()
   aTrsf.rotateZ(math.pi) # rotate around the z-axis
   
   aMirroredWire=aWire.transformGeometry(aTrsf)
   myWireProfile=Part.Wire([aWire,aMirroredWire])
   myFaceProfile=Part.Face(myWireProfile)
   aPrismVec=Base.Vector(0,0,myHeight)
   myBody=myFaceProfile.extrude(aPrismVec)
   myBody=myBody.makeFillet(myThickness/12.0,myBody.Edges)
   neckLocation=Base.Vector(0,0,myHeight)
   neckNormal=Base.Vector(0,0,1)
   myNeckRadius = myThickness / 4.
   myNeckHeight = myHeight / 10
   myNeck = Part.makeCylinder(myNeckRadius,myNeckHeight,neckLocation,neckNormal)	
   myBody = myBody.fuse(myNeck)
   
   faceToRemove = 0
   zMax = -1.0
   
   for xp in myBody.Faces:
       try:
           surf = xp.Surface
           if type(surf) == Part.Plane:
               z = surf.Position.z
               if z > zMax:
                   zMax = z
                   faceToRemove = xp
       except:
           continue
   
   myBody = myBody.makeFillet(myThickness/12.0,myBody.Edges)
   
   return myBody

el = makeBottle()
Part.show(el)

Détail et déroulement MakeBottle.py

import Part, FreeCAD, math
from FreeCAD import Base

Nous aurons besoin bien sûr du module Part mais aussi du module FreeCAD.Basequi contient les structures de base de FreeCAD comme les vectors et matrixes.

def makeBottle(myWidth=50.0, myHeight=70.0, myThickness=30.0):
   aPnt1=Base.Vector(-myWidth/2.,0,0)
   aPnt2=Base.Vector(-myWidth/2.,-myThickness/4.,0)
   aPnt3=Base.Vector(0,-myThickness/2.,0)
   aPnt4=Base.Vector(myWidth/2.,-myThickness/4.,0)
   aPnt5=Base.Vector(myWidth/2.,0,0)

Ici, nous définissons notre fonction MakeBottle.
Cette fonction peut être appelée sans argument, comme nous l'avons fait ci-dessus, les valeurs par défaut, de largeur, hauteur et épaisseur seront utilisés.
Ensuite, nous définissons une paire de points qui seront utilisés pour la construction de notre profil de base.

aArcOfCircle = Part.Arc(aPnt2,aPnt3,aPnt4)
   aSegment1=Part.LineSegment(aPnt1,aPnt2)
   aSegment2=Part.LineSegment(aPnt4,aPnt5)

C'est ici que nous définissons les formes géométriques: un arc composé de 3 points et deux segments de ligne de 2 points chacun.

aEdge1=aSegment1.toShape()
   aEdge2=aArcOfCircle.toShape()
   aEdge3=aSegment2.toShape()
   aWire=Part.Wire([aEdge1,aEdge2,aEdge3])

Vous vous souvenez de la différence entre la géométrie et les formes? Nous allons construire les formes de notre forme géométrique. Trois bords (bords ou arêtes peuvent être des segments de droites ou des courbes) puis nous raccordons tous les sommets.

aTrsf=Base.Matrix()
   aTrsf.rotateZ(math.pi) # rotate around the z-axis
   aMirroredWire=aWire.transformGeometry(aTrsf)
   myWireProfile=Part.Wire([aWire,aMirroredWire])

Jusqu'à présent, nous n'avons construit qu'un demi profil. Au lieu de construire le profil entier de la même manière, nous pouvons simplement reproduire ce que nous avons fait et coller les deux moitiés ensemble. Nous créons d'abord une matrice. Une matrice est un moyen très courant d'appliquer des transformations à des objets du monde 3D car elle peut contenir dans une structure toutes les transformations de base que peuvent subir les objets 3D (déplacement, rotation et mise à l'échelle). Après avoir créé la matrice, nous en faisons une symétrie puis nous créons une copie de notre fil avec cette matrice de transformation qui lui est appliquée. Nous avons maintenant deux fils et nous pouvons en faire un troisième, les fils étant en réalité des listes de bords.

myFaceProfile=Part.Face(myWireProfile)
   aPrismVec=Base.Vector(0,0,myHeight)
   myBody=myFaceProfile.extrude(aPrismVec)
   myBody=myBody.makeFillet(myThickness/12.0,myBody.Edges)

Maintenant, nous avons un contour fermé, il peut être transformé en une face. Une fois que nous avons une face, nous pouvons l'extruder.
Une fois fait, nous avons un solide. Puis, nous appliquons un filet à notre objet car nous voulons lui donner un aspect "design", n'est-ce pas?

neckLocation=Base.Vector(0,0,myHeight)
   neckNormal=Base.Vector(0,0,1)
   myNeckRadius = myThickness / 4.
   myNeckHeight = myHeight / 10
   myNeck = Part.makeCylinder(myNeckRadius,myNeckHeight,neckLocation,neckNormal)

À ce stade, le corps de notre bouteille est fabriqué mais nous devons encore créer un goulot. On fait un nouveau solide avec un cylindre.

myBody = myBody.fuse(myNeck)

L'opération de fusion, qui dans d'autres applications est parfois appelé union, est très puissante.
Cette opération prendra soin de coller ce qui doit être collé et enlever ce qui doit être enlevé.

return myBody

Puis, nous revenons à notre bouteille (Part solid), qui est le résultat de notre fonction.

el = makeBottle()
Part.show(el)

Enfin, nous appelons la fonction pour créer la pièce puis la rendons visible.

Cube percé

Ici un exemple complet de construction d'un cube percé.

La construction se fait face par face et quand le cube est terminé, il est évidé d'un cylindre traversant.

import Draft, Part, FreeCAD, math, PartGui, FreeCADGui, PyQt4
from math import sqrt, pi, sin, cos, asin
from FreeCAD import Base

size = 10
poly = Part.makePolygon( [ (0,0,0), (size, 0, 0), (size, 0, size), (0, 0, size), (0, 0, 0)])

face1 = Part.Face(poly)
face2 = Part.Face(poly)
face3 = Part.Face(poly)
face4 = Part.Face(poly)
face5 = Part.Face(poly)
face6 = Part.Face(poly)
     
myMat = FreeCAD.Matrix()
myMat.rotateZ(math.pi/2)
face2.transformShape(myMat)
face2.translate(FreeCAD.Vector(size, 0, 0))

myMat.rotateZ(math.pi/2)
face3.transformShape(myMat)
face3.translate(FreeCAD.Vector(size, size, 0))

myMat.rotateZ(math.pi/2)
face4.transformShape(myMat)
face4.translate(FreeCAD.Vector(0, size, 0))

myMat = FreeCAD.Matrix()
myMat.rotateX(-math.pi/2)
face5.transformShape(myMat)

face6.transformShape(myMat)               
face6.translate(FreeCAD.Vector(0,0,size))

myShell = Part.makeShell([face1,face2,face3,face4,face5,face6])   

mySolid = Part.makeSolid(myShell)
mySolidRev = mySolid.copy()
mySolidRev.reverse()

myCyl = Part.makeCylinder(2,20)
myCyl.translate(FreeCAD.Vector(size/2, size/2, 0))

cut_part = mySolidRev.cut(myCyl)

Part.show(cut_part)

Chargement et sauvegarde

Il ya plusieurs façons de sauver votre travail dans le Part Module . Vous pouvez bien sûr sauvegarder votre document au format FreeCAD, mais vous pouvez également enregistrer les objets directement dans un format courant de CAO, tels que BREP, IGS, STEP et STL.

L'enregistrement d'une forme (un projet) dans un fichier est facile, il y a les fonctions exportBrep(), exportIges(), exportStl() et exportStep() qui sont des méthodes disponibles pour toutes les formes d'objets.
Donc, en faisant:

import Part
s = Part.makeBox(0,0,0,10,10,10)
s.exportStep("test.stp")

Ceci sauve votre box (cube) dans le format .STP. Pour charger un fichier BREP, IGES ou STEP:

import Part
s = Part.Shape()
s.read("test.stp")

Pour convertir un fichier .stp en .igs:

import Part
 s = Part.Shape()
 s.read("file.stp")       # incoming file igs, stp, stl, brep
 s.exportIges("file.igs") # outbound file igs

Notez que l'importation ou l'ouverture de fichiers BREP, IGES ou STEP peut également être effectuée directement à partir du Menu Fichier → Ouvrir, Menu Fichier → Importer ou l'icone "Ouvrir un document ou importer des fichiers" et pour l'exportation d'un fichier par Menu Fichier → Exporter